services:
    ### MySQL DATABASE ###
    database:
        image: mariadb:10.1
        environment:
            MYSQL_ROOT_PASSWORD:    password
            MYSQL_DATABASE:         ${DB_NAME}
            MYSQL_USER:             ${DB_USER}
            MYSQL_PASSWORD:         ${DB_PASSWORD}
            TZ:                     ${TIMEZONE}
        volumes:
            - ./sql/import:/docker-entrypoint-initdb.d
        ports:
            - "${DB_PORT:-3306}:3306"

    ### WEB SERVER ###
    http:
        build: ./docker/httpd
        environment:
            TZ: ${TIMEZONE}
        ports:
            - "${HTTP_PORT:-8020}:80"
        depends_on:
            - php
            - database
            - mail
            - node
        volumes:
            - ./docker/httpd/vhosts/:/usr/local/apache2/conf/vhosts:ro
            - ./docker/httpd/httpd.conf:/usr/local/apache2/conf/httpd.conf:ro
            - ./appli_sf/:/srv/:ro
        networks:
            default:
                aliases:
                    - ${HTTP_HOSTNAME}

    ### PHP WITH XDEBUG ###
    php:
        build:
            context: ./docker/php
            args:
                ENVIRONMENT:      ${ENVIRONMENT}
                PHP_VERSION:      ${PHP_VERSION}
                COMPOSER_VERSION: ${COMPOSER_VERSION}
                XDEBUG_VERSION:   ${XDEBUG_VERSION}
                MY_IP:            ${MY_IP}
        container_name: depnot-php-1
        environment:
            TZ: ${TIMEZONE}
        working_dir: /srv
        env_file:
            - .env
        volumes:
            - ./appli_sf/:/srv/
            - ~/.composer/:/home/.composer/
            - ./docker/php/php-mail.conf:/usr/local/etc/php/conf.d/mailconf.ini
            - .git:/tmp/.git
            - ./hooks:/tmp/hooks

    ### MAIL SERVER ###
    mail:
        image: mailhog/mailhog
        environment:
            TZ: ${TIMEZONE}
        ports:
            - "${MAILER_SMTP_PORT:-1025}:1025"
            - "${MAILER_CLIENT_PORT:-8025}:8025"

    ### NODE FOR ASSETS COMPILATION ###
    node:
        build:
            context: ./docker/node
            args:
                NODE_VERSION: ${NODE_VERSION}
        working_dir: /srv
        volumes:
            - ./appli_sf/:/srv/

    e2e:
        build:
            context: ./docker/cypress
        depends_on:
            - http
            - database
            - mail
            - php
        environment:
            TZ:                 ${TIMEZONE}
            DISPLAY:            unix$DISPLAY
            CYPRESS_baseUrl:    http://${HTTP_HOSTNAME}
            CYPRESS_mailhogUrl: http://mail:${MAILER_CLIENT_PORT:-8025}
        working_dir: /srv/appli_sf/tests/E2E/
        volumes:
            - ./:/srv/
            - /tmp/.X11-unix:/tmp/.X11-unix
            - ${DOCKER_SOCK:-/var/run/docker.sock}:/var/run/docker.sock

volumes:
    database: ~
